module TypeDefine
!=========================================================================
!     Defines the derived type for storing the strength, position and flow
!     velocity for the point vortices.
!=========================================================================

      implicit none

      private ! none
      public :: Vortex

!     The informaton of the point vortices is stored in data_t
      type :: Vortex
        real(kind=8) :: Gamma      ! Votrex strength
        real(kind=8) :: xCoor      ! X-coordinate
        real(kind=8) :: yCoor      ! Y-coordinate
        real(kind=8) :: OldX       ! Point in memory to store the previous position of the vortex
        real(kind=8) :: OldY       ! Point in memory to store the previous position of the vortex
        real(kind=8) :: VelX       ! Velocity component in the x-direction
        real(kind=8) :: VelY       ! Velocity component in the y-direction
        real(kind=8) :: d1x
        real(kind=8) :: d1y
        real(kind=8) :: d2x
        real(kind=8) :: d2y
        integer :: age                ! Age of vortex (Number of time steps)
        type(Vortex), pointer :: Next ! Pointer which may point to a item of
      end type Vortex                 ! type Vortex (e.g next elemnt in list)

end module TypeDefine
